// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Message_HeaderFile
#define _Message_HeaderFile

#ifndef _Handle_Message_Messenger_HeaderFile
#include <Handle_Message_Messenger.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class Message_Messenger;
class TCollection_AsciiString;
class Message_Msg;
class Message_MsgFile;
class Message_Messenger;
class Message_Algorithm;
class Message_Printer;
class Message_PrinterOStream;
class Message_ListOfMsg;
class Message_SequenceOfPrinters;
class Message_ProgressIndicator;
class Message_ProgressScale;
class Message_ProgressSentry;
class Message_SequenceOfProgressScale;
class Message_ListNodeOfListOfMsg;
class Message_ListIteratorOfListOfMsg;
class Message_SequenceNodeOfSequenceOfPrinters;
class Message_SequenceNodeOfSequenceOfProgressScale;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Defines <br>
//!          - tools to work with messages <br>
//!          - basic tools intended for progress indication <br>
class Message  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Defines default messenger for OCCT applications. <br>
//!          This is global static instance of the messenger. <br>
//!          By default, it contains single printer directed to cout. <br>
//!          It can be customized according to the application needs. <br>
Standard_EXPORT static const Handle_Message_Messenger& DefaultMessenger() ;

//! Returns the string filled with values of hours, minutes and seconds. <br>
//! Example: <br>
//!          1. (5, 12, 26.3345) returns "05h:12m:26.33s", <br>
//!          2. (0,  6, 34.496 ) returns "06m:34.50s", <br>
//!          3. (0,  0,  4.5   ) returns "4.50s" <br>
Standard_EXPORT static  TCollection_AsciiString FillTime(const Standard_Integer Hour,const Standard_Integer Minute,const Standard_Real Second) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //

friend class Message_Msg;
friend class Message_MsgFile;
friend class Message_Messenger;
friend class Message_Algorithm;
friend class Message_Printer;
friend class Message_PrinterOStream;
friend class Message_ListOfMsg;
friend class Message_SequenceOfPrinters;
friend class Message_ProgressIndicator;
friend class Message_ProgressScale;
friend class Message_ProgressSentry;
friend class Message_SequenceOfProgressScale;
friend class Message_ListNodeOfListOfMsg;
friend class Message_ListIteratorOfListOfMsg;
friend class Message_SequenceNodeOfSequenceOfPrinters;
friend class Message_SequenceNodeOfSequenceOfProgressScale;

};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
